/*********************************************************************************/
/**                                                          	     		**/
/**  Dane s dwa dzbanki: 3-litrowy i 4-litrowy oraz ujcie wody. W stanie 	**/
/**  pocztkowy, obydwa dzbanki s puste. Znale sposb osignicia stanu	**/
/**  kocowego, w ktrym dzbanek 4-litrowy jest pusty a dzbanek 3-litrowy	**/
/**  zawiera 2 litry wody. Jednoczenie zakada si, e mona w tym celu	**/
/**  mona wykonywa wycznie wymienione niej dziaania.			**/
/**  1. Kady dzbanek mona (cakowicie) napeni lub oprni korzystajc z	**/
/**     ujcia wody.								**/
/**  2. Mona przelewa wod z jednego dzbanka do drugiego a do napenienia	**/
/**	dzbanka "docelowego" lub oprnienia dzbanka "rdowego".		**/
/**                                                          	     		**/
/**  Zapytanie o rozwizanie:							**/
/**     ?- solve([0,0],[0,2],P).                  				**/
/**                                                          	     		**/
/**  Zapytanie o rozwizanie najkrtsze:					**/
/**    ?- findall(P,solve([0,0],[0,2],P),LP),min_length(LP,M,_).		**/
/**  Wynikiem jest warto zmiennej M. Podcel z predefiniowanym predykatem 	**/
/**  findall/3 tworzy list LP wszystkich rozwiza rozpatrywanego problemu.	**/ 
/**  Predykat min_length(+LLst,?Min,?MinLen) w oglnoci suy do znajdowania	**/
/**  na licie list LLst elementu Min o dugoci MinLen takiej, e dugo 	**/
/**  adnego innego elementu listy LLst nie jest mniejsza od MinLen. W toku	**/
/**  nawrotw, pod zmienn Min zostaj podstawione wszystkie elementy listy 	**/
/**  LLst, speniajce ww. warunek.						**/
/*********************************************************************************/

solve(B,E,P):-
	path(B,E,[B],P1),
	reverse(P1,P).

path(B,B,W,W).
path(B,E,Wp,W):-
	next_state(B,B1),
	not(member(B1,Wp)),
	path(B1,E,[B1|Wp],W).

next_state([X,Y],[0,Y]) :- X > 0.
next_state([X,Y],[X,0]) :- Y > 0.
next_state([X,Y],[4,Y]) :- X < 4.
next_state([X,Y],[X,3]) :- Y < 3.
next_state([X,Y],[4,Z]) :- X < 4, Z is Y - (4 - X), Z >= 0.
next_state([X,Y],[Z,3]) :- Y < 3, Z is X - (3 - Y), Z >= 0.
next_state([X,Y],[Z,0]) :- Y > 0, Z is X + Y, Z =< 4.
next_state([X,Y],[0,Z]) :- X > 0, Z is X + Y, Z =< 3.

/*********************************************************************************/

min_length([H],H,LH) :- length(H,LH), !.
min_length([H|T],MT,LMT) :-
  length(H,LH), 
  min_length(T,MT,LMT),
  LMT =< LH.
min_length([H|T],H,LH) :-
  length(H,LH), 
  min_length(T,_,LMT),
  LH =< LMT,!.
